package MOAParser;

public class ExtendedPayload {

  public final static int EXTENDED_0_1 = 0x00000001;
  public final static int EXTENDED_1_1 = 0x00000002;
  public final static int EXTENDED_2_1 = 0x00000004;
  public final static int EXTENDED_3_1 = 0x00000008;
  public final static int EXTENDED_4_1 = 0x00000010;
  public final static int EXTENDED_5_2 = 0x00000020;
  public final static int EXTENDED_6_2 = 0x00000040;
  public final static int EXTENDED_7_2 = 0x00000080;
  public final static int EXTENDED_8_2 = 0x00000100;
  public final static int EXTENDED_9_2 = 0x00000200;
  public final static int EXTENDED_10_2 = 0x0000400;
  public final static int EXTENDED_11_2 = 0x0000800;
  public final static int EXTENDED_12_2 = 0x0001000;
  public final static int EXTENDED_13_2 = 0x0002000;
  public final static int EXTENDED_14_2 = 0x0004000;
  public final static int EXTENDED_15_2 = 0x00008000;
  public final static int EXTENDED_16_2 = 0x00010000;
  public final static int EXTENDED_17_2 = 0x00020000;
  public final static int EXTENDED_18_2 = 0x00040000;
  public final static int EXTENDED_19_2 = 0x00080000;
  public final static int EXTENDED_20_4 = 0x00100000;
  public final static int EXTENDED_21_4 = 0x00200000;
  public final static int EXTENDED_22_4 = 0x00400000;
  public final static int EXTENDED_23_4 = 0x00800000;
  public final static int EXTENDED_24_4 = 0x01000000;
  public final static int EXTENDED_25_4 = 0x02000000;
  public final static int EXTENDED_26_4 = 0x04000000;
  public final static int EXTENDED_27_254 = 0x08000000;
  public final static int EXTENDED_28_254 = 0x10000000;
  public final static int EXTENDED_29_254 = 0x20000000;
  public final static int EXTENDED_30_254 = 0x40000000;
  public final static int EXTENDEDMAP = 0x80000000;

  public static void parse(ByteBufferReader dis, IParsedLocation parsed, long extendedBitmap) {

    Location major = parsed.getLocations().get(0);
    if ((extendedBitmap & ExtendedPayload.EXTENDED_0_1) > 0) {
      byte newCelStatus = (byte) (dis.getUnsignedByte() & 0x80);
      newCelStatus = newCelStatus == 0 ? MoaParser.CEL_STATUS_OFF : MoaParser.CEL_STATUS_ON;
      major.setCelStatus(newCelStatus);
    }
    if ((extendedBitmap & ExtendedPayload.EXTENDED_1_1) > 0) {
      short accel = (short) (dis.getByte() * MoaParser.CM2_IN_G / 100F);
      major.setAccel(accel);
    }
    if ((extendedBitmap & ExtendedPayload.EXTENDED_2_1) > 0) {
      dis.getUnsignedByte();
    }
    if ((extendedBitmap & ExtendedPayload.EXTENDED_3_1) > 0) {
      dis.getUnsignedByte();
    }
    if ((extendedBitmap & ExtendedPayload.EXTENDED_4_1) > 0) {
      dis.getUnsignedByte();
    }
    if ((extendedBitmap & ExtendedPayload.EXTENDED_5_2) > 0) {
      dis.getShortBE();
    }
    if ((extendedBitmap & ExtendedPayload.EXTENDED_6_2) > 0) {
      major.setDistance(dis.getUnsignedShortBE());
    }
    if ((extendedBitmap & ExtendedPayload.EXTENDED_7_2) > 0) {
      dis.getShortBE();
    }
    if ((extendedBitmap & ExtendedPayload.EXTENDED_8_2) > 0) {
      dis.getShortBE();
    }
    if ((extendedBitmap & ExtendedPayload.EXTENDED_9_2) > 0) {
      dis.getShortBE();
    }
    if ((extendedBitmap & ExtendedPayload.EXTENDED_10_2) > 0) {
      dis.getShortBE();
    }
    if ((extendedBitmap & ExtendedPayload.EXTENDED_11_2) > 0) {
      dis.getShortBE();
    }
    if ((extendedBitmap & ExtendedPayload.EXTENDED_12_2) > 0) {
      dis.getShortBE();
    }
    if ((extendedBitmap & ExtendedPayload.EXTENDED_13_2) > 0) {
      dis.getShortBE();
    }
    if ((extendedBitmap & ExtendedPayload.EXTENDED_14_2) > 0) {
      dis.getShortBE();
    }
    if ((extendedBitmap & ExtendedPayload.EXTENDED_15_2) > 0) {
      dis.getShortBE();
    }
    if ((extendedBitmap & ExtendedPayload.EXTENDED_16_2) > 0) {
      dis.getShortBE();
    }
    if ((extendedBitmap & ExtendedPayload.EXTENDED_17_2) > 0) {
      dis.getShortBE();
    }
    if ((extendedBitmap & ExtendedPayload.EXTENDED_18_2) > 0) {
      dis.getShortBE();
    }
    if ((extendedBitmap & ExtendedPayload.EXTENDED_19_2) > 0) {
      dis.getShortBE();
    }
    if ((extendedBitmap & ExtendedPayload.EXTENDED_20_4) > 0) {
      dis.getIntBE();
    }
    if ((extendedBitmap & ExtendedPayload.EXTENDED_21_4) > 0) {
      dis.getIntBE();
    }
    if ((extendedBitmap & ExtendedPayload.EXTENDED_22_4) > 0) {
      dis.getIntBE();
    }
    if ((extendedBitmap & ExtendedPayload.EXTENDED_23_4) > 0) {
      dis.getIntBE();
    }
    if ((extendedBitmap & ExtendedPayload.EXTENDED_24_4) > 0) {
      dis.getIntBE();
    }
    if ((extendedBitmap & ExtendedPayload.EXTENDED_25_4) > 0) {
      dis.getIntBE();
    }
    if ((extendedBitmap & ExtendedPayload.EXTENDED_26_4) > 0) {
      dis.getIntBE();
    }
    if ((extendedBitmap & ExtendedPayload.EXTENDED_27_254) > 0) {
      dis.getString();
    }
    if ((extendedBitmap & ExtendedPayload.EXTENDED_28_254) > 0) {
      dis.getString();
    }
    if ((extendedBitmap & ExtendedPayload.EXTENDED_29_254) > 0) {
      dis.getString();
    }
    if ((extendedBitmap & ExtendedPayload.EXTENDED_30_254) > 0) {
      dis.getString();
    }
    if ((extendedBitmap & ExtendedPayload.EXTENDEDMAP) > 0) {
      dis.getIntBE();
    }
  }

}
