package MOAParser;

import java.util.ArrayList;
import java.util.List;

public interface IParsedLocation {
  public final static int SERIAL = 0;
  public final static int MEID = 1;
  public final static int IMEI = 2;
  public final static int IP_ADDRESS = 3;

  public final static int STATUS_GOOD = 0;
  public final static int STATUS_BAD = 1;
  public final static int STATUS_ACK_GOOD = 2;
  public final static int STATUS_ACK_BAD = 3;
  public final static int STATUS_VERSION_RESPONSE = 4;
  public final static int STATUS_CUSTOM = 6;
  public final static int STATUS_UNKNOWN = 5;
 
  //locations.clear();
  //statusId = ParsedLocation.STATUS_GOOD;
  //deviceId = null;
  //typeId = ParsedLocation.SERIAL;
  //sequence = 0;

  /**
   * The device ID is the primary identification field for the device.  
   * Depending on the parser, it might be the MEID or IMEI.
   */
  public String getDeviceId();
  public void setDeviceId(String deviceId);

  /**
   * List of Locations parsed by the parser.
   * @see MOAParser.Location
   */
  public List<Location> getLocations();
  public void addLocation(Location location);

  /**
   * The sequence number of the message (if applicable).
   */
  public int getSequence();
  public void setSequence(int sequence);

  /**
   * The status of parsing the message
   */
  public int getStatus();
  public void setStatus(int value);

  /**
   * The type that the DeviceID is.  The current values are:
   *   ParsedLocation.SERIAL = 0
   *   ParsedLocation.MEID   = 1
   *   ParsedLocation.IMEI   = 2
   */
  public int getTypeId();
  public void setTypeId(int typeId);

}

