package MOAParserExample;

import java.nio.ByteBuffer;

import org.apache.commons.codec.binary.Hex;

import MOAParser.MoaParser;
import MOAParser.IParsedLocation;

public class Main {

  public static void main(String[] args) throws Exception {
    // Door open
    //byte[] data = Hex.decodeHex("00014562e90a4facc14497ef0b000000d4aa5cbf9980139843edba23a45400440533020fb900000000010015");

    // OBD Message
    //byte[] data = Hex.decodeHex("00014223b30df27f6d002fff025cc09cf35cc09d00001398432cba23a52c0000081100c300".toCharArray());

    // One Major with 4 minors and ACK
    //byte[] data = Hex.decodeHex("000143D3D7662869C1E49FEF18055E46AE545E46AE54139241ACBA2A4BB5000A051F260A0DAF01004E000000030000dEFF9AFFF50DF8FF4000F417FBFEB8FFCF1BFBFFFEFE6114".toCharArray());

    //byte[] data = Hex.decodeHex("000143d3d75ceb1dc1d49fef6b055ea8680e5ea8680e186f5684d3ff3d16291f058c230a25a501004e0000000100fcfee9fe9c1ef8feeaff730afbff28013928fbfeb201fd24fbfec401c52afbffdd02df34fb0000038235fbff9803542efbff8102b420".toCharArray());
    
    byte[] data = Hex.decodeHex("000143d3d74bf3ef6d00ffff035ed182cfa53147314a4335343434523732353233363700000000000000000000000000be1b30138002200144000000000000000000000000000000".toCharArray());
 
    IParsedLocation parsed = new ParsedLocation();
    MoaParser parser = new MoaParser();

    ByteBuffer input = ByteBuffer.wrap(data);
    ByteBuffer ack;

    ack = parser.handleLocation(input, parsed);

    System.out.println("Input");
    System.out.println(Hex.encodeHex(input.position(0)));
    System.out.println();

    System.out.println("Parsed");
    System.out.println(parsed);

    if (ack != null) {
      System.out.println("Ack");
      ack.position(0);
      byte[] ackBytes = ack.array();
      System.out.println(String.format("%-14s 0x%02x (%d)", "Message type:", ackBytes[0], ackBytes[0]));
      System.out.println(String.format("%-14s 0x%02x (%d)", "Sequence #:", ackBytes[1], ackBytes[1]));
    } else {
      System.out.println("No ACK");
    }
  }
}
